BIG WireGuard TCP implementation patch

Kernel baseline: Linux v6.8 (90d1f30371ae3337beb01666b226320728d35c70)
Tools baseline: wireguard-tools a998407747005ea7e4e0258d96f105c97241e1d3
Target repository: https://github.com/secwest/WireguardTCP.git
Target source commit: ae38aea0ac0a0d08c7410500ff020a414d13a627

This patch contains only the allowlisted kernel module, UAPI, and wg source
changes needed to build and run WireguardTCP. Upstream kernel crypto, SIMD,
and architecture assembly are not modified by this patch.

Prepare the baseline from clean official checkouts:

    git clone https://github.com/torvalds/linux.git linux
    git -C linux checkout 90d1f30371ae3337beb01666b226320728d35c70
    git clone https://github.com/WireGuard/wireguard-tools.git wireguard-tools
    git -C wireguard-tools checkout a998407747005ea7e4e0258d96f105c97241e1d3
    mkdir WireguardTCP-patch-base
    cp -a linux/drivers/net/wireguard WireguardTCP-patch-base/kernel
    mkdir -p WireguardTCP-patch-base/include/uapi/linux
    cp linux/include/uapi/linux/wireguard.h WireguardTCP-patch-base/include/uapi/linux/
    cp -a wireguard-tools/src WireguardTCP-patch-base/tools

Apply and build on Ubuntu 24.04 with matching kernel headers installed:

    cd WireguardTCP-patch-base
    git apply --binary /path/to/BIG-WireguardTCP-Patch
    make -C tools -j$(nproc)
    make -C /lib/modules/$(uname -r)/build M=$PWD/kernel CONFIG_WIREGUARD=m -j$(nproc) modules
diff --git a/include/uapi/linux/wireguard.h b/include/uapi/linux/wireguard.h
index 0efd52c3687d981dcac4b074cc0aea3362457e9d..d6d288022773b1a8697345cb304058441e1c9984 100644
--- a/include/uapi/linux/wireguard.h
+++ b/include/uapi/linux/wireguard.h
@@ -29,6 +29,7 @@
  *    WGDEVICE_A_PUBLIC_KEY: NLA_EXACT_LEN, len WG_KEY_LEN
  *    WGDEVICE_A_LISTEN_PORT: NLA_U16
  *    WGDEVICE_A_FWMARK: NLA_U32
+ *    WGDEVICE_A_TRANSPORT: NLA_U8, WG_TRANSPORT_UDP or WG_TRANSPORT_TCP
  *    WGDEVICE_A_PEERS: NLA_NESTED
  *        0: NLA_NESTED
  *            WGPEER_A_PUBLIC_KEY: NLA_EXACT_LEN, len WG_KEY_LEN
@@ -81,8 +82,11 @@
  *    WGDEVICE_A_FLAGS: NLA_U32, 0 or WGDEVICE_F_REPLACE_PEERS if all current
  *                      peers should be removed prior to adding the list below.
  *    WGDEVICE_A_PRIVATE_KEY: len WG_KEY_LEN, all zeros to remove
- *    WGDEVICE_A_LISTEN_PORT: NLA_U16, 0 to choose randomly
+ *    WGDEVICE_A_LISTEN_PORT: NLA_U16, 0 to choose randomly at interface-up;
+ *                            changing it on a running TCP device returns EBUSY
  *    WGDEVICE_A_FWMARK: NLA_U32, 0 to disable
+ *    WGDEVICE_A_TRANSPORT: NLA_U8, WG_TRANSPORT_UDP or WG_TRANSPORT_TCP;
+ *                          omission preserves the current transport
  *    WGDEVICE_A_PEERS: NLA_NESTED
  *        0: NLA_NESTED
  *            WGPEER_A_PUBLIC_KEY: len WG_KEY_LEN
@@ -101,6 +105,10 @@
  *                    WGALLOWEDIP_A_FAMILY: NLA_U16
  *                    WGALLOWEDIP_A_IPADDR: struct in_addr or struct in6_addr
  *                    WGALLOWEDIP_A_CIDR_MASK: NLA_U8
+ *                    WGALLOWEDIP_A_FLAGS: NLA_U32, WGALLOWEDIP_F_REMOVE_ME if
+ *                                         the specified IP should be removed;
+ *                                         otherwise, this IP will be added if
+ *                                         it is not already present.
  *                0: NLA_NESTED
  *                    ...
  *                0: NLA_NESTED
@@ -136,6 +144,9 @@
 
 #define WG_KEY_LEN 32
 
+#define WG_TRANSPORT_UDP 0
+#define WG_TRANSPORT_TCP 1
+
 enum wg_cmd {
 	WG_CMD_GET_DEVICE,
 	WG_CMD_SET_DEVICE,
@@ -157,6 +168,7 @@ enum wgdevice_attribute {
 	WGDEVICE_A_LISTEN_PORT,
 	WGDEVICE_A_FWMARK,
 	WGDEVICE_A_PEERS,
+	WGDEVICE_A_TRANSPORT,
 	__WGDEVICE_A_LAST
 };
 #define WGDEVICE_A_MAX (__WGDEVICE_A_LAST - 1)
@@ -184,11 +196,16 @@ enum wgpeer_attribute {
 };
 #define WGPEER_A_MAX (__WGPEER_A_LAST - 1)
 
+enum wgallowedip_flag {
+	WGALLOWEDIP_F_REMOVE_ME = 1U << 0,
+	__WGALLOWEDIP_F_ALL = WGALLOWEDIP_F_REMOVE_ME
+};
 enum wgallowedip_attribute {
 	WGALLOWEDIP_A_UNSPEC,
 	WGALLOWEDIP_A_FAMILY,
 	WGALLOWEDIP_A_IPADDR,
 	WGALLOWEDIP_A_CIDR_MASK,
+	WGALLOWEDIP_A_FLAGS,
 	__WGALLOWEDIP_A_LAST
 };
 #define WGALLOWEDIP_A_MAX (__WGALLOWEDIP_A_LAST - 1)
diff --git a/kernel/Makefile b/kernel/Makefile
index dbe1f8514efc3df1175762c62d71f88fe6327835..36bfc716d4d57c58121361a63bf29611a88e603d 100644
--- a/kernel/Makefile
+++ b/kernel/Makefile
@@ -1,5 +1,14 @@
 ccflags-y := -D'pr_fmt(fmt)=KBUILD_MODNAME ": " fmt'
+ccflags-y += -I$(src)/../include -I$(src)/../include/uapi
+ccflags-y += -include $(src)/wireguard_tcp_uapi.h
 ccflags-$(CONFIG_WIREGUARD_DEBUG) += -DDEBUG
+
+# WireGuard TCP debug levels (add to EXTRA_CFLAGS or uncomment here):
+#   -DWG_TCP_VERBOSE    Function enter/exit traces, param dumps (very noisy)
+#   -DWG_TCP_DIAG       TCP performance diagnostics (cwnd, rtt, retrans)
+#   Neither              No debug output (production)
+# Example: make ... EXTRA_CFLAGS="-DWG_TCP_DIAG"
+# ccflags-y += -DWG_TCP_VERBOSE -DWG_TCP_DIAG
 wireguard-y := main.o
 wireguard-y += noise.o
 wireguard-y += device.o
@@ -9,6 +18,8 @@ wireguard-y += queueing.o
 wireguard-y += send.o
 wireguard-y += receive.o
 wireguard-y += socket.o
+wireguard-y += wg_tcp.o
+wireguard-y += wg_tcp_debug.o
 wireguard-y += peerlookup.o
 wireguard-y += allowedips.o
 wireguard-y += ratelimiter.o
diff --git a/kernel/allowedips.c b/kernel/allowedips.c
index 0ba714ca5185cd94124bd121a49117b79b9898bc..411a940b0e548fe484bfcaa10e14206a1c7d23b3 100644
--- a/kernel/allowedips.c
+++ b/kernel/allowedips.c
@@ -5,6 +5,7 @@
 
 #include "allowedips.h"
 #include "peer.h"
+#include "wg_tcp_debug.h"
 
 enum { MAX_ALLOWEDIPS_DEPTH = 129 };
 
@@ -12,17 +13,20 @@ static struct kmem_cache *node_cache;
 
 static void swap_endian(u8 *dst, const u8 *src, u8 bits)
 {
+	wg_dbg("Entering swap_endian(dst=%px, src=%px, bits=%u)\n", dst, src, bits);
 	if (bits == 32) {
 		*(u32 *)dst = be32_to_cpu(*(const __be32 *)src);
 	} else if (bits == 128) {
-		((u64 *)dst)[0] = be64_to_cpu(((const __be64 *)src)[0]);
-		((u64 *)dst)[1] = be64_to_cpu(((const __be64 *)src)[1]);
+		((u64 *)dst)[0] = get_unaligned_be64(src);
+		((u64 *)dst)[1] = get_unaligned_be64(src + 8);
 	}
+	wg_dbg("Exiting swap_endian\n");
 }
 
 static void copy_and_assign_cidr(struct allowedips_node *node, const u8 *src,
 				 u8 cidr, u8 bits)
 {
+	wg_dbg("Entering copy_and_assign_cidr(node=%px, src=%px, cidr=%u, bits=%u)\n", node, src, cidr, bits);
 	node->cidr = cidr;
 	node->bit_at_a = cidr / 8U;
 #ifdef __LITTLE_ENDIAN
@@ -31,30 +35,39 @@ static void copy_and_assign_cidr(struct allowedips_node *node, const u8 *src,
 	node->bit_at_b = 7U - (cidr % 8U);
 	node->bitlen = bits;
 	memcpy(node->bits, src, bits / 8U);
+	wg_dbg("Exiting copy_and_assign_cidr\n");
 }
 
 static inline u8 choose(struct allowedips_node *node, const u8 *key)
 {
-	return (key[node->bit_at_a] >> node->bit_at_b) & 1;
+	wg_dbg("Entering choose(node=%px, key=%px)\n", node, key);
+	u8 result = (key[node->bit_at_a] >> node->bit_at_b) & 1;
+	wg_dbg("Exiting choose with result=%u\n", result);
+	return result;
 }
 
 static void push_rcu(struct allowedips_node **stack,
 		     struct allowedips_node __rcu *p, unsigned int *len)
 {
+	wg_dbg("Entering push_rcu(stack=%px, p=%px, len=%u)\n", stack, p, *len);
 	if (rcu_access_pointer(p)) {
 		if (WARN_ON(IS_ENABLED(DEBUG) && *len >= MAX_ALLOWEDIPS_DEPTH))
 			return;
 		stack[(*len)++] = rcu_dereference_raw(p);
 	}
+	wg_dbg("Exiting push_rcu\n");
 }
 
 static void node_free_rcu(struct rcu_head *rcu)
 {
+	wg_dbg("Entering node_free_rcu(rcu=%px)\n", rcu);
 	kmem_cache_free(node_cache, container_of(rcu, struct allowedips_node, rcu));
+	wg_dbg("Exiting node_free_rcu\n");
 }
 
 static void root_free_rcu(struct rcu_head *rcu)
 {
+	wg_dbg("Entering root_free_rcu(rcu=%px)\n", rcu);
 	struct allowedips_node *node, *stack[MAX_ALLOWEDIPS_DEPTH] = {
 		container_of(rcu, struct allowedips_node, rcu) };
 	unsigned int len = 1;
@@ -64,10 +77,12 @@ static void root_free_rcu(struct rcu_head *rcu)
 		push_rcu(stack, node->bit[1], &len);
 		kmem_cache_free(node_cache, node);
 	}
+	wg_dbg("Exiting root_free_rcu\n");
 }
 
 static void root_remove_peer_lists(struct allowedips_node *root)
 {
+	wg_dbg("Entering root_remove_peer_lists(root=%px)\n", root);
 	struct allowedips_node *node, *stack[MAX_ALLOWEDIPS_DEPTH] = { root };
 	unsigned int len = 1;
 
@@ -77,40 +92,53 @@ static void root_remove_peer_lists(struct allowedips_node *root)
 		if (rcu_access_pointer(node->peer))
 			list_del(&node->peer_list);
 	}
+	wg_dbg("Exiting root_remove_peer_lists\n");
 }
 
 static unsigned int fls128(u64 a, u64 b)
 {
-	return a ? fls64(a) + 64U : fls64(b);
+	wg_dbg("Entering fls128(a=%llu, b=%llu)\n", a, b);
+	unsigned int result = a ? fls64(a) + 64U : fls64(b);
+	wg_dbg("Exiting fls128 with result=%u\n", result);
+	return result;
 }
 
 static u8 common_bits(const struct allowedips_node *node, const u8 *key,
 		      u8 bits)
 {
+	wg_dbg("Entering common_bits(node=%px, key=%px, bits=%u)\n", node, key, bits);
+	u8 result;
 	if (bits == 32)
-		return 32U - fls(*(const u32 *)node->bits ^ *(const u32 *)key);
+		result = 32U - fls(*(const u32 *)node->bits ^ *(const u32 *)key);
 	else if (bits == 128)
-		return 128U - fls128(
+		result = 128U - fls128(
 			*(const u64 *)&node->bits[0] ^ *(const u64 *)&key[0],
 			*(const u64 *)&node->bits[8] ^ *(const u64 *)&key[8]);
-	return 0;
+	else
+		result = 0;
+	wg_dbg("Exiting common_bits with result=%u\n", result);
+	return result;
 }
 
 static bool prefix_matches(const struct allowedips_node *node, const u8 *key,
 			   u8 bits)
 {
+	wg_dbg("Entering prefix_matches(node=%px, key=%p, bits=%u)\n", node, key, bits);
 	/* This could be much faster if it actually just compared the common
 	 * bits properly, by precomputing a mask bswap(~0 << (32 - cidr)), and
 	 * the rest, but it turns out that common_bits is already super fast on
 	 * modern processors, even taking into account the unfortunate bswap.
 	 * So, we just inline it like this instead.
 	 */
-	return common_bits(node, key, bits) >= node->cidr;
+	bool result = common_bits(node, key, bits) >= node->cidr;
+	wg_dbg("Exiting prefix_matches with result=%d\n", result);
+	return result;
 }
 
 static struct allowedips_node *find_node(struct allowedips_node *trie, u8 bits,
 					 const u8 *key)
 {
+	wg_dbg("Entering find_node(trie=%px, bits=%u, key=%px)\n", trie, bits, key);
 	struct allowedips_node *node = trie, *found = NULL;
 
 	while (node && prefix_matches(node, key, bits)) {
@@ -120,13 +148,16 @@ static struct allowedips_node *find_node(struct allowedips_node *trie, u8 bits,
 			break;
 		node = rcu_dereference_bh(node->bit[choose(node, key)]);
 	}
+	wg_dbg("Exiting find_node with found=%px\n", found);
 	return found;
 }
 
+
 /* Returns a strong reference to a peer */
 static struct wg_peer *lookup(struct allowedips_node __rcu *root, u8 bits,
 			      const void *be_ip)
 {
+	wg_dbg("Entering lookup(root=%px, bits=%u, be_ip=%px)\n", root, bits, be_ip);
 	/* Aligned so it can be passed to fls/fls64 */
 	u8 ip[16] __aligned(__alignof(u64));
 	struct allowedips_node *node;
@@ -143,13 +174,16 @@ retry:
 			goto retry;
 	}
 	rcu_read_unlock_bh();
+	wg_dbg("Exiting lookup with peer=%px\n", peer);
 	return peer;
 }
 
+
 static bool node_placement(struct allowedips_node __rcu *trie, const u8 *key,
 			   u8 cidr, u8 bits, struct allowedips_node **rnode,
 			   struct mutex *lock)
 {
+	wg_dbg("Entering node_placement(trie=%px, key=%px, cidr=%u, bits=%u, rnode=%px, lock=%px)\n", trie, key, cidr, bits, rnode, lock);
 	struct allowedips_node *node = rcu_dereference_protected(trie, lockdep_is_held(lock));
 	struct allowedips_node *parent = NULL;
 	bool exact = false;
@@ -163,24 +197,30 @@ static bool node_placement(struct allowedips_node __rcu *trie, const u8 *key,
 		node = rcu_dereference_protected(parent->bit[choose(parent, key)], lockdep_is_held(lock));
 	}
 	*rnode = parent;
+	wg_dbg("Exiting node_placement with exact=%d\n", exact);
 	return exact;
 }
 
 static inline void connect_node(struct allowedips_node __rcu **parent, u8 bit, struct allowedips_node *node)
 {
+	wg_dbg("Entering connect_node(parent=%px, bit=%u, node=%px)\n", parent, bit, node);
 	node->parent_bit_packed = (unsigned long)parent | bit;
 	rcu_assign_pointer(*parent, node);
+	wg_dbg("Exiting connect_node\n");
 }
 
 static inline void choose_and_connect_node(struct allowedips_node *parent, struct allowedips_node *node)
 {
+	wg_dbg("Entering choose_and_connect_node(parent=%px, node=%px)\n", parent, node);
 	u8 bit = choose(parent, node->bits);
 	connect_node(&parent->bit[bit], bit, node);
+	wg_dbg("Exiting choose_and_connect_node\n");
 }
 
 static int add(struct allowedips_node __rcu **trie, u8 bits, const u8 *key,
 	       u8 cidr, struct wg_peer *peer, struct mutex *lock)
 {
+	wg_dbg("Entering add(trie=%px, bits=%u, key=%px, cidr=%u, peer=%px, lock=%px)\n", trie, bits, key, cidr, peer, lock);
 	struct allowedips_node *node, *parent, *down, *newnode;
 
 	if (unlikely(cidr > bits || !peer))
@@ -194,11 +234,13 @@ static int add(struct allowedips_node __rcu **trie, u8 bits, const u8 *key,
 		list_add_tail(&node->peer_list, &peer->allowedips_list);
 		copy_and_assign_cidr(node, key, cidr, bits);
 		connect_node(trie, 2, node);
+		wg_dbg("Exiting add with return 0\n");
 		return 0;
 	}
 	if (node_placement(*trie, key, cidr, bits, &node, lock)) {
 		rcu_assign_pointer(node->peer, peer);
 		list_move_tail(&node->peer_list, &peer->allowedips_list);
+		wg_dbg("Exiting add with return 0\n");
 		return 0;
 	}
 
@@ -216,6 +258,7 @@ static int add(struct allowedips_node __rcu **trie, u8 bits, const u8 *key,
 		down = rcu_dereference_protected(node->bit[bit], lockdep_is_held(lock));
 		if (!down) {
 			connect_node(&node->bit[bit], bit, newnode);
+			wg_dbg("Exiting add with return 0\n");
 			return 0;
 		}
 	}
@@ -228,6 +271,7 @@ static int add(struct allowedips_node __rcu **trie, u8 bits, const u8 *key,
 			connect_node(trie, 2, newnode);
 		else
 			choose_and_connect_node(parent, newnode);
+		wg_dbg("Exiting add with return 0\n");
 		return 0;
 	}
 
@@ -246,17 +290,72 @@ static int add(struct allowedips_node __rcu **trie, u8 bits, const u8 *key,
 		connect_node(trie, 2, node);
 	else
 		choose_and_connect_node(parent, node);
+	wg_dbg("Exiting add with return 0\n");
+	return 0;
+}
+
+static void remove_node(struct allowedips_node *node, struct mutex *lock)
+{
+	struct allowedips_node *child, **parent_bit, *parent;
+	bool free_parent;
+
+	list_del_init(&node->peer_list);
+	RCU_INIT_POINTER(node->peer, NULL);
+	if (node->bit[0] && node->bit[1])
+		return;
+	child = rcu_dereference_protected(
+		node->bit[!rcu_access_pointer(node->bit[0])],
+		lockdep_is_held(lock));
+	if (child)
+		child->parent_bit_packed = node->parent_bit_packed;
+	parent_bit = (struct allowedips_node **)(node->parent_bit_packed & ~3UL);
+	*parent_bit = child;
+	parent = (void *)parent_bit -
+		 offsetof(struct allowedips_node, bit[node->parent_bit_packed & 1]);
+	free_parent = !rcu_access_pointer(node->bit[0]) &&
+		      !rcu_access_pointer(node->bit[1]) &&
+		      (node->parent_bit_packed & 3) <= 1 &&
+		      !rcu_access_pointer(parent->peer);
+	if (free_parent)
+		child = rcu_dereference_protected(
+			parent->bit[!(node->parent_bit_packed & 1)],
+			lockdep_is_held(lock));
+	call_rcu(&node->rcu, node_free_rcu);
+	if (!free_parent)
+		return;
+	if (child)
+		child->parent_bit_packed = parent->parent_bit_packed;
+	*(struct allowedips_node **)(parent->parent_bit_packed & ~3UL) = child;
+	call_rcu(&parent->rcu, node_free_rcu);
+}
+
+static int remove(struct allowedips_node __rcu **trie, u8 bits, const u8 *key,
+		  u8 cidr, struct wg_peer *peer, struct mutex *lock)
+{
+	struct allowedips_node *node;
+
+	if (unlikely(cidr > bits))
+		return -EINVAL;
+	if (!rcu_access_pointer(*trie) ||
+	    !node_placement(*trie, key, cidr, bits, &node, lock) ||
+	    peer != rcu_access_pointer(node->peer))
+		return 0;
+
+	remove_node(node, lock);
 	return 0;
 }
 
 void wg_allowedips_init(struct allowedips *table)
 {
+	wg_dbg("Entering wg_allowedips_init(table=%px)\n", table);
 	table->root4 = table->root6 = NULL;
 	table->seq = 1;
+	wg_dbg("Exiting wg_allowedips_init\n");
 }
 
 void wg_allowedips_free(struct allowedips *table, struct mutex *lock)
 {
+	wg_dbg("Entering wg_allowedips_free(table=%px, lock=%px)\n", table, lock);
 	struct allowedips_node __rcu *old4 = table->root4, *old6 = table->root6;
 
 	++table->seq;
@@ -276,72 +375,74 @@ void wg_allowedips_free(struct allowedips *table, struct mutex *lock)
 		root_remove_peer_lists(node);
 		call_rcu(&node->rcu, root_free_rcu);
 	}
+	wg_dbg("Exiting wg_allowedips_free\n");
 }
 
 int wg_allowedips_insert_v4(struct allowedips *table, const struct in_addr *ip,
 			    u8 cidr, struct wg_peer *peer, struct mutex *lock)
 {
+	wg_dbg("Entering wg_allowedips_insert_v4(table=%px, ip=%px, cidr=%u, peer=%px, lock=%px)\n", table, ip, cidr, peer, lock);
 	/* Aligned so it can be passed to fls */
 	u8 key[4] __aligned(__alignof(u32));
 
 	++table->seq;
 	swap_endian(key, (const u8 *)ip, 32);
-	return add(&table->root4, 32, key, cidr, peer, lock);
+	int result = add(&table->root4, 32, key, cidr, peer, lock);
+	wg_dbg("Exiting wg_allowedips_insert_v4 with result=%d\n", result);
+	return result;
 }
 
 int wg_allowedips_insert_v6(struct allowedips *table, const struct in6_addr *ip,
 			    u8 cidr, struct wg_peer *peer, struct mutex *lock)
 {
+	wg_dbg("Entering wg_allowedips_insert_v6(table=%px, ip=%px, cidr=%u, peer=%px, lock=%px)\n", table, ip, cidr, peer, lock);
 	/* Aligned so it can be passed to fls64 */
 	u8 key[16] __aligned(__alignof(u64));
 
 	++table->seq;
 	swap_endian(key, (const u8 *)ip, 128);
-	return add(&table->root6, 128, key, cidr, peer, lock);
+	int result = add(&table->root6, 128, key, cidr, peer, lock);
+	wg_dbg("Exiting wg_allowedips_insert_v6 with result=%d\n", result);
+	return result;
+}
+
+int wg_allowedips_remove_v4(struct allowedips *table, const struct in_addr *ip,
+			    u8 cidr, struct wg_peer *peer, struct mutex *lock)
+{
+	u8 key[4] __aligned(__alignof(u32));
+
+	++table->seq;
+	swap_endian(key, (const u8 *)ip, 32);
+	return remove(&table->root4, 32, key, cidr, peer, lock);
+}
+
+int wg_allowedips_remove_v6(struct allowedips *table, const struct in6_addr *ip,
+			    u8 cidr, struct wg_peer *peer, struct mutex *lock)
+{
+	u8 key[16] __aligned(__alignof(u64));
+
+	++table->seq;
+	swap_endian(key, (const u8 *)ip, 128);
+	return remove(&table->root6, 128, key, cidr, peer, lock);
 }
 
 void wg_allowedips_remove_by_peer(struct allowedips *table,
 				  struct wg_peer *peer, struct mutex *lock)
 {
-	struct allowedips_node *node, *child, **parent_bit, *parent, *tmp;
-	bool free_parent;
+	wg_dbg("Entering wg_allowedips_remove_by_peer(table=%px, peer=%px, lock=%px)\n", table, peer, lock);
+	struct allowedips_node *node, *tmp;
 
 	if (list_empty(&peer->allowedips_list))
 		return;
 	++table->seq;
-	list_for_each_entry_safe(node, tmp, &peer->allowedips_list, peer_list) {
-		list_del_init(&node->peer_list);
-		RCU_INIT_POINTER(node->peer, NULL);
-		if (node->bit[0] && node->bit[1])
-			continue;
-		child = rcu_dereference_protected(node->bit[!rcu_access_pointer(node->bit[0])],
-						  lockdep_is_held(lock));
-		if (child)
-			child->parent_bit_packed = node->parent_bit_packed;
-		parent_bit = (struct allowedips_node **)(node->parent_bit_packed & ~3UL);
-		*parent_bit = child;
-		parent = (void *)parent_bit -
-			 offsetof(struct allowedips_node, bit[node->parent_bit_packed & 1]);
-		free_parent = !rcu_access_pointer(node->bit[0]) &&
-			      !rcu_access_pointer(node->bit[1]) &&
-			      (node->parent_bit_packed & 3) <= 1 &&
-			      !rcu_access_pointer(parent->peer);
-		if (free_parent)
-			child = rcu_dereference_protected(
-					parent->bit[!(node->parent_bit_packed & 1)],
-					lockdep_is_held(lock));
-		call_rcu(&node->rcu, node_free_rcu);
-		if (!free_parent)
-			continue;
-		if (child)
-			child->parent_bit_packed = parent->parent_bit_packed;
-		*(struct allowedips_node **)(parent->parent_bit_packed & ~3UL) = child;
-		call_rcu(&parent->rcu, node_free_rcu);
-	}
+	list_for_each_entry_safe(node, tmp, &peer->allowedips_list, peer_list)
+		remove_node(node, lock);
+	wg_dbg("Exiting wg_allowedips_remove_by_peer\n");
 }
 
 int wg_allowedips_read_node(struct allowedips_node *node, u8 ip[16], u8 *cidr)
 {
+	wg_dbg("Entering wg_allowedips_read_node(node=%px, ip=%px, cidr=%px)\n", node, ip, cidr);
 	const unsigned int cidr_bytes = DIV_ROUND_UP(node->cidr, 8U);
 	swap_endian(ip, node->bits, node->bitlen);
 	memset(ip + cidr_bytes, 0, node->bitlen / 8U - cidr_bytes);
@@ -349,41 +450,58 @@ int wg_allowedips_read_node(struct allowedips_node *node, u8 ip[16], u8 *cidr)
 		ip[cidr_bytes - 1U] &= ~0U << (-node->cidr % 8U);
 
 	*cidr = node->cidr;
-	return node->bitlen == 32 ? AF_INET : AF_INET6;
+	int result = node->bitlen == 32 ? AF_INET : AF_INET6;
+	wg_dbg("Exiting wg_allowedips_read_node with result=%d\n", result);
+	return result;
 }
 
 /* Returns a strong reference to a peer */
 struct wg_peer *wg_allowedips_lookup_dst(struct allowedips *table,
 					 struct sk_buff *skb)
 {
+	wg_dbg("Entering wg_allowedips_lookup_dst(table=%px, skb=%px)\n", table, skb);
+	struct wg_peer *result;
 	if (skb->protocol == htons(ETH_P_IP))
-		return lookup(table->root4, 32, &ip_hdr(skb)->daddr);
+		result = lookup(table->root4, 32, &ip_hdr(skb)->daddr);
 	else if (skb->protocol == htons(ETH_P_IPV6))
-		return lookup(table->root6, 128, &ipv6_hdr(skb)->daddr);
-	return NULL;
+		result = lookup(table->root6, 128, &ipv6_hdr(skb)->daddr);
+	else
+		result = NULL;
+	wg_dbg("Exiting wg_allowedips_lookup_dst with result=%px\n", result);
+	return result;
 }
 
 /* Returns a strong reference to a peer */
 struct wg_peer *wg_allowedips_lookup_src(struct allowedips *table,
 					 struct sk_buff *skb)
 {
+	wg_dbg("Entering wg_allowedips_lookup_src(table=%px, skb=%px)\n", table, skb);
+	struct wg_peer *result;
 	if (skb->protocol == htons(ETH_P_IP))
-		return lookup(table->root4, 32, &ip_hdr(skb)->saddr);
+		result = lookup(table->root4, 32, &ip_hdr(skb)->saddr);
 	else if (skb->protocol == htons(ETH_P_IPV6))
-		return lookup(table->root6, 128, &ipv6_hdr(skb)->saddr);
-	return NULL;
+		result = lookup(table->root6, 128, &ipv6_hdr(skb)->saddr);
+	else
+		result = NULL;
+	wg_dbg("Exiting wg_allowedips_lookup_src with result=%px\n", result);
+	return result;
 }
 
 int __init wg_allowedips_slab_init(void)
 {
+	wg_dbg("Entering wg_allowedips_slab_init()\n");
 	node_cache = KMEM_CACHE(allowedips_node, 0);
-	return node_cache ? 0 : -ENOMEM;
+	int result = node_cache ? 0 : -ENOMEM;
+	wg_dbg("Exiting wg_allowedips_slab_init with result=%d\n", result);
+	return result;
 }
 
 void wg_allowedips_slab_uninit(void)
 {
+	wg_dbg("Entering wg_allowedips_slab_uninit()\n");
 	rcu_barrier();
 	kmem_cache_destroy(node_cache);
+	wg_dbg("Exiting wg_allowedips_slab_uninit\n");
 }
 
 #include "selftest/allowedips.c"
diff --git a/kernel/allowedips.h b/kernel/allowedips.h
index 2346c797eb4d877d76504e3e23d4d2b5dc831f1a..931958cb6e100c99c71d66e03e2ba4ffb199f07d 100644
--- a/kernel/allowedips.h
+++ b/kernel/allowedips.h
@@ -38,6 +38,10 @@ int wg_allowedips_insert_v4(struct allowedips *table, const struct in_addr *ip,
 			    u8 cidr, struct wg_peer *peer, struct mutex *lock);
 int wg_allowedips_insert_v6(struct allowedips *table, const struct in6_addr *ip,
 			    u8 cidr, struct wg_peer *peer, struct mutex *lock);
+int wg_allowedips_remove_v4(struct allowedips *table, const struct in_addr *ip,
+			    u8 cidr, struct wg_peer *peer, struct mutex *lock);
+int wg_allowedips_remove_v6(struct allowedips *table, const struct in6_addr *ip,
+			    u8 cidr, struct wg_peer *peer, struct mutex *lock);
 void wg_allowedips_remove_by_peer(struct allowedips *table,
 				  struct wg_peer *peer, struct mutex *lock);
 /* The ip input pointer should be __aligned(__alignof(u64))) */
diff --git a/kernel/cookie.h b/kernel/cookie.h
index c4bd61ca03f24230fd0f0cdaae231cb7a6aa29b8..10ac1f5ac65d142d37f1fcdb3bcb7276077f9168 100644
--- a/kernel/cookie.h
+++ b/kernel/cookie.h
@@ -38,6 +38,24 @@ enum cookie_mac_state {
 	VALID_MAC_WITH_COOKIE
 };
 
+enum cookie_validation_action {
+	WG_COOKIE_DROP,
+	WG_COOKIE_ACCEPT,
+	WG_COOKIE_CHALLENGE
+};
+
+static inline enum cookie_validation_action
+wg_cookie_validation_action(bool under_load, enum cookie_mac_state mac_state)
+{
+	if (under_load && mac_state == VALID_MAC_WITH_COOKIE)
+		return WG_COOKIE_ACCEPT;
+	if (!under_load && mac_state == VALID_MAC_BUT_NO_COOKIE)
+		return WG_COOKIE_ACCEPT;
+	if (under_load && mac_state == VALID_MAC_BUT_NO_COOKIE)
+		return WG_COOKIE_CHALLENGE;
+	return WG_COOKIE_DROP;
+}
+
 void wg_cookie_checker_init(struct cookie_checker *checker,
 			    struct wg_device *wg);
 void wg_cookie_checker_precompute_device_keys(struct cookie_checker *checker);
@@ -56,4 +74,8 @@ void wg_cookie_message_create(struct message_handshake_cookie *src,
 void wg_cookie_message_consume(struct message_handshake_cookie *src,
 			       struct wg_device *wg);
 
+#ifdef DEBUG
+bool wg_cookie_policy_selftest(void);
+#endif
+
 #endif /* _WG_COOKIE_H */
